#!/bin/bash

# Takes as input a xml file generated by run_xml.sh and run beast on it
# until the ess are good or give up if errors or too many trials

WDIR_PATH=$(dirname "$0")

inputXML=$1
repID="$(basename -- $inputXML)"
repID="${repID%.xml}"
outdir="$(dirname $inputXML)"
#outdirBeast="${outdir%%/XML*}/Beast_logs"
ESSmin=200
burnin=0.1
doPlot=TRUE

logfiles=( )
cleanup() {
  echo "$(date) Error, removing logfiles ${logfiles[@]}"
  rm -f "${logfiles[@]}"
}

error() {
  local parent_lineno="$1"
  local message="$2"
  local code="${3:-1}"
  #cleanup
  if [[ -n "$message" ]] ; then
    echo "$(date) ERROR on or near line ${parent_lineno}: ${message}; exiting with status ${code}"
  else
    echo "$(date) ERROR on or near line ${parent_lineno}; exiting with status ${code}"
  fi
  exit "${code}"
}
trap 'error ${LINENO}' ERR


echo "$(date) Starting for $repID"

while [ ! -f "$outdir/beast_$repID.log" ]
do
    if [ "$ESSmin" -le 130 ]; then
        echo "$(date) too many attempts and still bad ESS for $repID"
        echo "$(date) DEBUG mv $outdir/beast\_$repID\_140.log $outdir/beast\_$repID\_essfailed.log"
        mv "$outdir"/beast_"$repID"_140.log "$outdir"/beast_"$repID"_essfailed.log
        logfiles+=( "$outdir/beast_$repID_essfailed.log" )
        break
    fi
    echo "$(date) Running Beast for $repID"
    echo "$(date) DEBUG beast $inputXML > $outdir/beast_$repID.log"
    beast "$inputXML" > "$outdir/beast_$repID.log"
    logfiles+=( "$outdir/beast_$repID.log" )
    echo "$(date) Running Babette, test ESS"
    echo "$(date) DEBUG Rscript $WDIR_PATH/babette_ESS.R --vanilla $outdir beast_$repID $ESSmin"
    Rscript "$WDIR_PATH/babette_ESS.R" --vanilla "$outdir" "$repID" "$ESSmin"
    logfiles+=( "$outdir/beast_$repID_$ESSmin.log" )
    ESSmin=$((ESSmin-10))
done

if [ -f "$outdir/beast_$repID_EBSP.log" ]
then
    echo "$(date) Plotting $repID"
    echo "$(date) DEBUG Rscript $WDIR_PATH/plot.R --vanilla $outdir beast_$repID $burnin $doPlot"
    Rscript "$WDIR_PATH/plot.R" --vanilla "$outdir" "beast_$repID" "$burnin" "$doPlot"
fi
echo "$(date) Done for $repID"
